/*
* generated by Xtext
*/
package org.eclipse.etrice.core.fsm.ui.labeling

import com.google.inject.Inject
import org.eclipse.etrice.core.fsm.fSM.SimpleState
import org.eclipse.etrice.core.fsm.fSM.RefinedState
import org.eclipse.etrice.core.fsm.fSM.State
import org.eclipse.etrice.core.common.ui.labeling.BaseLabelProvider
import org.eclipse.etrice.core.fsm.fSM.StateGraph
import org.eclipse.etrice.core.fsm.fSM.ModelComponent
import org.eclipse.etrice.core.fsm.fSM.Transition
import org.eclipse.etrice.core.fsm.fSM.Trigger

/**
 * Provides labels for a EObjects.
 * 
 * see http://www.eclipse.org/Xtext/documentation.html#labelProvider
 */
class FSMLabelProvider extends BaseLabelProvider {

	@Inject
	new(org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider delegate) {
		super(delegate);
	}


	def String image(SimpleState state) {
		"State.gif"
	}

	def String image(RefinedState state) {
		"RefinedState.gif"
	}
	
	def String text(State s) {
		"state " + s.name
	}
	
	def String text(Transition trans) {
		"transition " + trans.name
	}
	
	def String text(Trigger tr) {
		"trigger"
	}
	
	def String text(StateGraph sm) {
		if (sm.eContainer instanceof ModelComponent)
			"state machine"
		else
			"state graph"
	}
}
